// ***************************************************************
//  TransferPrinter FW Version:  1.0     date: 06/17/2007
//  -------------------------------------------------------------
//  File Name : Globals.h
//  -------------------------------------------------------------
//  Copyright (C) 2007 - All Rights Reserved
//	Author : Markus Stopper
// ***************************************************************
// Description: Holds all global Includes
// ***************************************************************

//****************************************************************
// Defines
//****************************************************************

#ifndef __GLOGBALS__
#define __GLOGBALS__

// CPU frequency 
//#define F_CPU 800000UL
// CPU Type
#define MCU atmega8
// Programming Flags 8MHz internal
#define CKSEL0  0
#define CKSEL1	0
#define CKSEL2	1
#define CKSEL3	0
// Startup Times 4.1ms fast rising Power
#define SUT0	1
#define SUT1	0

//****************************************************************
// Timer0 Defines
//****************************************************************
// Timer 0 Reload Value
#define TIMER0_RELOAD (255-8)

//****************************************************************
// Standard Data Types
//****************************************************************
#include <stdint.h>
typedef unsigned char BYTE;
typedef unsigned int WORD;
typedef uint32_t DWORD;

//****************************************************************
// Includes
//****************************************************************
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
//#include "pt.h"
#include "SegmentDriver.h"
#include "InitHardware.h"
#include "switches.h"
#include "ADC.h"

//****************************************************************
// Application Global Variables
//****************************************************************

char Beat;

#endif /*__GLOGBALS__*/
